/*------------------------------------------------------------------------------
--  This file is a part of the VHDL Tools Software
--  Copyright (C) 2014, Plasma Physics Laboratory - CNRS
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 2 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-------------------------------------------------------------------------------*/
/*--                  Author : Alexis Jeandet
--                     Mail : alexis.jeandet@member.fsf.org
----------------------------------------------------------------------------*/
#ifndef VHDL_FRAGMENT_H
#define VHDL_FRAGMENT_H
#include "vhdl_ast_node.h"
namespace VHDL_Tools {
class VHDL_Fragment
{
public:
    VHDL_Fragment();
    virtual void pushNode(VHDL_Tools::VHDL_AST_Node* node)=0;
    VHDL_Tools::VHDL_AST_Node* node;
};

class VHDL_packaget: public VHDL_Tools::VHDL_Fragment
{
public:
    VHDL_packaget() {}
    void pushNode(VHDL_Tools::VHDL_AST_Node* node);
    QString name;
};

class VHDL_entity: public VHDL_Tools::VHDL_Fragment
{
public:
    VHDL_entity() {}
    void pushNode(VHDL_Tools::VHDL_AST_Node* node);
    QString name;
};

class VHDL_architecture: public VHDL_Tools::VHDL_Fragment
{
public:
    VHDL_architecture() {}
    void pushNode(VHDL_Tools::VHDL_AST_Node* node);
    QString name;
};

class VHDL_component: public VHDL_Tools::VHDL_Fragment
{
public:
    VHDL_component() {}
    void pushNode(VHDL_Tools::VHDL_AST_Node* node);
    QString name;
};

class VHDL_Library: public VHDL_Tools::VHDL_Fragment
{
public:
    VHDL_Library() {}
    void pushNode(VHDL_Tools::VHDL_AST_Node* node);
    QString name;
};

class VHDL_useClose: public VHDL_Tools::VHDL_Fragment
{
public:
    VHDL_useClose() {}
    void pushNode(VHDL_Tools::VHDL_AST_Node* node);
    QString name;
};

class VHDL_generic: public VHDL_Tools::VHDL_Fragment
{
public:
    VHDL_generic() {}
    void pushNode(VHDL_Tools::VHDL_AST_Node* node);
    QString name;
};

class VHDL_port: public VHDL_Tools::VHDL_Fragment
{
public:
    VHDL_port() {}
    void pushNode(VHDL_Tools::VHDL_AST_Node* node);
    QString name;
};

class VHDL_type: public VHDL_Tools::VHDL_Fragment
{
public:
    VHDL_type() {}
    void pushNode(VHDL_Tools::VHDL_AST_Node* node);
    QString name;
};

class VHDL_subtype: public VHDL_Tools::VHDL_Fragment
{
public:
    VHDL_subtype() {}
    void pushNode(VHDL_Tools::VHDL_AST_Node* node);
    QString name;
};

class VHDL_constant: public VHDL_Tools::VHDL_Fragment
{
public:
    VHDL_constant() {}
    void pushNode(VHDL_Tools::VHDL_AST_Node* node);
    QString name;
};

class VHDL_signal: public VHDL_Tools::VHDL_Fragment
{
public:
    VHDL_signal() {}
    void pushNode(VHDL_Tools::VHDL_AST_Node* node);
    QString name;
};

}
#endif // VHDL_FRAGMENT_H
